(* remember to compile via ocamlc -vmthread threads.cma hw5c.ml 
   and put any other flags between -vmthread and threads.cma
*)
(* Note: This program NEVER TERMINATES. See comment at the end of file. *)
open Thread
open Event

let mystery_f lst = 
  let rec make_evs lst i =
    match lst with
      [] -> []
    | hd::tl -> (wrap (receive hd) (fun b -> (b,i)))::(make_evs tl (i+1)) in 
  let evs = make_evs lst 0 in
  let enuf = 
    let len = List.length lst in
    if len mod 2 = 0
    then len / 2
    else (len / 2) + 1 in
  let rec loop y n old =
    let (b,i) = sync (choose evs) in
    if List.mem i old
    then loop y n old
    else (if b
          then ((if y+1 = enuf then (print_string "Y"; flush stdout) else ());
		loop (y+1) n (i::old))
          else ((if n+1 = enuf then (print_string "N"; flush stdout) else ());
	        loop y (n+1) (i::old)))
  in
  create (loop 0 0) []

(* some testing code, but not enough to get the program to do anything *)
let ch1 = new_channel()
let ch2 = new_channel()
let ch3 = new_channel()
let ch4 = new_channel()
let ch5 = new_channel()

let mystery_thread = mystery_f [ch1;ch2;ch3;ch4;ch5]

let _ = sync (send ch1 true)

(* you can put more or different message-passing here to see if mystery_f
   behaves as you expect *)

(* advice: do *not* try to deduce its full behavior via black-box testing.
   You will probably infer an incomplete description and you will
   learn less. *)

(* A Caml program ends with the main thread ends.  The mystery-thread
never ends, so this join means the program never ends.  So use
Control-C or your favorite method to kill a process.  If we omit this
join, we can (in certain situations) have a race between main-thread
termination and the mystery-thread printing something. *)
let _ = Thread.join mystery_thread
